﻿Whats = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")

Whats:RegisterChatCommand("/Whats", options)

local TipHooker = AceLibrary("TipHooker-1.0")
local SharedMedia = AceLibrary("SharedMedia-1.0")
local DD = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Whats")

local self = Whats

local _G = _G

local menuTable = { }


Whats.Menu = { 
	type = "group", 
	args = {
		Open = {
			name = L["Open"],
			order = 1,
			type = "execute",
			desc = L["Display Whats Menu"],
			func = function() self:OnClick() DD:Close() end,
		},
		Search = {
			name = L["Search"],
			order = 2,
			type = "text",
			usage = L["Item ID or Item name"],
			desc = L["Searching Items"],
			get = false,
			set = function(t) self.Search(t) end
		},
		Appearance = {
			type = "group",
			name = L["Appearance"],
			order = 2,
			desc = L["Set Whats Displey Option."],
			args = {
				Border = {
					type = "text",
					name = L["Border"],
					desc = L["Set Border"],
					validate = SharedMedia:List('border'),
					get = function() return self.db.profile.border end,
					set = function(b) 
						self.db.profile.border = b Whats:ApplySetting()
						Whats:ApplySetting()
					end
				},
				Width = {
					type = "group",
					name = L["Width"],
					desc = L["Set Width of Whats menu and Whats Item button."],
					args = {
						Menu = {
							type = "range",
							name = L["Menu"],
							desc = L["Set width of Whats menu."],
							min = 100,
							max = 200,
							step = 10,
							get = function() return self.db.profile.menuWidth end,
							set = function(r) 
								self.db.profile.menuWidth = r 
								Whats:ApplySetting()
							end
						},
						Button = {
							type = "range",
							name = L["Button"],
							desc = L["Set width of Whats item button."],
							min = 128,
							max = 188,
							step = 10,
							get = function() return self.db.profile.buttonWidth end,
							set = function(r) 
								self.db.profile.buttonWidth = r 
								Whats:ApplySetting()
							end
						}
					}
				},
				Color = {
					type = "group",
					name = L["Color"],
					desc = L["Set color of Whats elements"],
					args = {
						Checked = {
							type = "color",
							name = L["Chached Item"],
							desc = L["Set color of chached item button."],
							get = function() return self.db.profile.Ccolor.r, self.db.profile.Ccolor.g, self.db.profile.Ccolor.b, self.db.profile.Ccolor.a end,
							set = function(r, g, b, a) self.db.profile.Ccolor.r, self.db.profile.Ccolor.g, self.db.profile.Ccolor.b, self.db.profile.Ccolor.a = r, g, b, a end,
						},
						Unchecked = {
							type = "color",
							name = L["Unchached Item"],
							desc = L["Set color of unchached item button"],
							get = function() return self.db.profile.Ucolor.r, self.db.profile.Ucolor.g, self.db.profile.Ucolor.b, self.db.profile.Ucolor.a end,
							set = function(r, g, b, a) self.db.profile.Ucolor.r, self.db.profile.Ucolor.g, self.db.profile.Ucolor.b, self.db.profile.Ucolor.a = r, g, b, a end,
						},
						Nochecked = {
							type = "color",
							name = L["No chached Item"],
							desc = L["Set color of no chached item button."],
							get = function() return self.db.profile.Ncolor.r, self.db.profile.Ncolor.g, self.db.profile.Ncolor.b, self.db.profile.Ncolor.a end,
							set = function(r, g, b, a) self.db.profile.Ncolor.r, self.db.profile.Ncolor.g, self.db.profile.Ncolor.b, self.db.profile.Ncolor.a = r, g, b, a end,
						},
						Menu = {
							type = "color",
							name = L["Menu"],
							desc = L["Set color of menu."],
							get = function() return self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a end,
							set = function(r, g, b, a) self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a = r, g, b, a end,
						}
					}
				},
				Texture = {
					name = L["Texture"],
					type = "text",
					desc = L["Set texture."],
					validate = SharedMedia:List('background'),
					get = function() return self.db.profile.texture end,
					set = function(t) 
						self.db.profile.texture = t 
						Whats:ApplySetting()
					end
				},
				Font = {
					name = L["Font"],
					type = "text",
					desc = L["Set font."],
					validate = SharedMedia:List('font'),
					get = function() return self.db.profile.font end,
					set = function(f) 
						self.db.profile.font = f 
						Whats:ApplySetting()
					end
				},
				Growth = {
					name = L["Direction"],
					type = "text",
					desc = L["Set growth direction"],
					validate = {["U"] = L["Up"], ["D"] = L["Down"], ["L"] = L["Left"], ["R"] = L["Right"]},
					get = function() return self.db.profile.growth end,
					set = function(g) 
						self.db.profile.growth = g 
						Whats:ApplySetting()
					end

				},
				Column = {
					name = L["Column"],
					type = "range",
					desc = L["Set column of item button"],
					min = 2,
					max = 4,
					step = 1,
					get = function() return self.db.profile.column end,
					set = function(c) 
						self.db.profile.column = c 
						Whats:ApplySetting()
					end
				}
			}
		}
	}
}


Whats.hasIcon = "Interface\\Icons\\INV_Misc_QuestionMark"
Whats.defaultPosition = "RIGHT"
Whats.hasNoColor = true
Whats.cannotDetachTooltip = true
Whats.hideWithoutStandby = true
Whats.OnMenuRequest = Whats.Menu

local WhatsSearchList = { }
local WhatsResultList = { }

function Whats:OnInitialize()
	self:RegisterDB("WhatsDB")
	self:RegisterDefaults("profile", 
		{
			border = "Blizzard Dialog",
			menuWidth = 100,
			buttonWidth = 128,
			texture = "Blizzard Tooltip",
			font = "Arial Narrow",
			column = 2,
			growth = "D",
			Ccolor = {r = 0.2, g = 0.2, b = 1, a = 0.8 },
			Ucolor = {r = 0.2, g = 1, b = 0.2, a = 0.8 },
			Ncolor = {r = 1, g = 0.2, b = 0.2, a = 0.8 },
			Mcolor = {r = 1, g = 1, b = 1, a = 1 },
		}
	)
	self:RegisterChatCommand({"/Whats"}, self.Menu)
	if WhatsItemDB == nil then
		WhatsItemDB = { }
	end
	self:RegisterChatCommand({'/ws'}, self.Search)
end

function Whats:OnEnable()
	TipHooker:Hook(self.ProcessTooltip, "item")

	if Links then
		Links:AddToMenu(L["|CFF00CED1W|r|CFFFFFFFFhats|r: Link Drop Info"], 
		function (_, _, link)
			local itemid = tonumber(select(3, strfind(link, "item:(%d+):")))
			if WhatsItemDB[itemid] then
				if not ChatFrameEditBox:IsVisible() then
					ChatFrameEditBox:Show()
				end
				ChatFrameEditBox:Insert("|CFF00CED1W|r|CFFFFFFFFhats|r: :".. WhatsItemDB[itemid] .. " "..self:GetText(itemid, true))
			end
		end)
	end

end

function Whats:OnDisable()
	TipHooker:Unhook(self.ProcessTooltip, "item")
end

function Whats:OnClick()
	if _G["WhatsMenu0"] and _G["WhatsMenu0"]:IsVisible() then
		local num = 0
		while (_G["WhatsMenu"..num]) do
			_G["WhatsMenu"..num]:Hide()
			num = num + 1
		end
		num = 1
		while (_G["WhatsButton"..num]) do
			_G["WhatsButton"..num]:Hide()
			num = num + 1
		end
	else
		local frame = self:OpenFrame(0, WhatsMainMenu)
		frame.pattern = ""

	end
end

function Whats.PrintResult()
	self:CancelScheduledEvent('WhatsPrintSearch')
	for k, v in pairs(WhatsResultList) do
		if GetItemInfo(v) then
			self.Search(v)
		else
			DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r : "..v.." -  "..L["No Data"], 1, 1, 1)
		end
		table.remove(WhatsResultList, tonumber(k))
		if #WhatsResultList == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r : "..L["Searching Finished"], 1, 1, 1)
		else
			Whats:ScheduleRepeatingEvent('WhatsPrintSearch', Whats.PrintResult, 3, Whats)
		end
	end
end

function Whats.SearchResult()
	self:CancelScheduledEvent('WhatsIDSearch')
	for k, v in pairs(WhatsSearchList) do
		table.remove(WhatsSearchList, tonumber(k))
		table.insert(WhatsResultList, v)
		if #WhatsSearchList > 0 and not Whats:IsEventScheduled('WhatsIDSearch') then
			GameTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
			GameTooltip:SetHyperlink("item:"..v)
			GameTooltip:Hide()
			Whats:ScheduleRepeatingEvent('WhatsIDSearch', Whats.SearchResult, 2.5, Whats)
			return
		end
		if #WhatsSearchList == 0 then
			Whats:ScheduleRepeatingEvent('WhatsPrintSearch', Whats.PrintResult, 2.5, Whats)
		end
	end
end

function Whats.Search(temp)
	if tonumber(temp) then
		local id = tonumber(temp)
		if GetItemInfo(id) then
			if WhatsItemInfo[id] then
				DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r :"..select(2, GetItemInfo(id)).." - "..self:GetText(id, false), 1, 1, 1)
			else
				if select(3, string.find(select(2, GetItemInfo(id)), "%[(.+)%]")) then
					WhatsItemDB[id] = select(2, GetItemInfo(id))
				end
				DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r :"..select(2, GetItemInfo(id)), 1, 1, 1)
			end
		else
			WhatsSearchList[#WhatsSearchList+1] = id

			if not Whats:IsEventScheduled('WhatsIDSearch') then
				GameTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
				GameTooltip:SetHyperlink("item:"..id)
				GameTooltip:Hide()
				Whats:ScheduleRepeatingEvent('WhatsIDSearch', Whats.SearchResult, 2.5, Whats)
			end
		end
	elseif temp == "" or temp == nil then
		DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r : "..L["For Searching, need Item ID or Item name"], 1, 1, 1)
	else
		local num = 0
		for k, v in pairs(WhatsItemDB) do
			if strfind(select(3, string.find(v, "%[(.+)%]")), temp) then
				Whats.Search(tonumber(k))
				num = num + 1
			end
		end
		if num == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r :"..temp.." -  "..L["No Data"], 1, 1, 1)
		else
			DEFAULT_CHAT_FRAME:AddMessage("|CFF00CED1W|r|CFFFFFFFFhats|r : "..string.format(L["Found %d items"], num), 1, 1, 1)
		end
	end
end

function Whats.ProcessTooltip(tooltip, name, link)
	local _, _, itemid = strfind(link, "item:(%d+):")
	if itemid then
		itemid = tonumber(itemid)
		if WhatsItemInfo[itemid] then
			if not WhatsItemDB[itemid] and select(3, string.find(link, "%[(.+)%]")) and strlen(select(3, string.find(link, "%[(.+)%]"))) > 1 then
				WhatsItemDB[itemid] = link
			end
			Whats:AddInfoToTooltip(itemid, tooltip)
			tooltip:Show()
		end
	end
end

function Whats:InstanceDrop(t, chat)
	local text, InsNum, insColor, MobNum, LastInstance, flag, Instance, White, ColorEnd

	if chat == false then
		if t[1] == "Ih" then
			insColor = "|CFFFF69B4"
		elseif t[1] == "Ib" then
			insColor = "|CFF6495ED"
		else
			insColor = "|CFF90EE90"
		end
		ColorEnd = "|r"
		White = "|CFFFFFFFF"
	else
		insColor = ""
		ColorEnd = ""
		White = ""
	end

	flag = true
	for ConNum, InsNum, MobNum in string.gmatch(t[2], "(%d+)-(%d+)-(%d+)") do
		ConNum = tonumber(ConNum)
		InsNum = tonumber(InsNum)
		MobNum = tonumber(MobNum)
		Instance = WhatsMobInfo[ConNum][InsNum][0]
		if text ~= nil then
			if Instance ~= LastInstance then
				flag = false
				text = text..insColor.."<"..LastInstance..">"..ColorEnd
			end
			text = text..White.."/"..WhatsMobInfo[ConNum][InsNum][MobNum][0]..ColorEnd
		else
			text = White..WhatsMobInfo[ConNum][InsNum][MobNum][0]..ColorEnd
		end
		LastInstance = Instance
	end
	text = text..insColor.."<"..Instance..">"..ColorEnd
	return text
end

function Whats:ExchangeItem(t, chat)
	local fac, npc, require, text

	_, _, npc, npcinfo = string.find(t[2], "(%d+)-?(%d*)")
	npc = tonumber(npc)
	
	text = WhatsExchangeNPCInfo[npc]

	if npcinfo then
		npcinfo = tonumber(npcinfo)
		if npc == 1 and npcinfo == 2 then
			text = text.."(v2.3)"
		end
	end

	if require == "" and npc == 8 then
		text = text .." "..L["Drop"]
	else
		text = text .." : "
	end


	text = text..WhatsItemMenu[t[5]].." "

	for item,num in string.gmatch(t[3],"(%d*)-?(%d*)") do
		if item ~= nil and item ~= "" then
			item = tonumber(item)
			local n = self:GetLink(item)
			if n ~= nil then
				text = text..n
			else
				text = text.."Item:"..item
			end
			if num ~= nil and num ~= "" and num ~= "1" then
				text = text.."x"..num.." "
			else
				text = text.." "
			end
		end
	end


	if text ~= nil then
		return text
	end
end

function Whats:ArenaItem(t, chat)

	local season, class, sub, point, require, text
	_, _, season, class, sub = strfind(t[2], "(%d+)-(%d+)-(%d+)")
	_, _, point, require = strfind(t[3], "(%d*):*(.*)")

	season = tonumber(season)
	class = tonumber(class)
	sub = tonumber(sub)

	text = L["Arena"] .. " ".. string.format(L["Season %d"], season).." :"
	
	if class > 0 and WhatsClassInfo[class] then
		text = text.." "..WhatsClassInfo[class][0].." "
		if sub > 0 and WhatsClassInfo[class][sub]then
			text = text .."("..WhatsClassInfo[class][sub][0]..") "
		end
	else
		text = text.." "..WhatsItemMenu[t[5]].." "
	end

	if season > 1 then
		text = text.." "..L["Arena"] .. " " ..L["Point"].." "..point..L["p"].. " "
	else
		text = text.." "..L["PvP"] .. " ".. L["Point"] .. " " ..point..L["p"].. " "
	end

	for item,num in string.gmatch(require,"(%d*)-?(%d*)") do
		if item ~= nil and item ~= "" then
			item = tonumber(item)
			local n = self:GetLink(item)
			if n ~= nil then
				text = text..n
			else
				text = text.."Item:"..item
			end
			if num ~= nil and num ~= "" and num ~= "1" then
				text = text.."x"..num.." "
			else
				text = text.." "
			end
		end
	end

	
	if text ~= nil then
		return text
	end
end

function Whats:ReputationItem(t, chat)
	local expantion, faction, class, sub, standing, require, text

	_, _, expantion, faction, class, sub = strfind(t[2], "(%d+)-(%d+)-(%d+)-(%d+)")
	_, _, standing, require = strfind(t[3], "(%d*):?(.*)")

	expantion = tonumber(expantion)
	faction = tonumber(faction)
	class = tonumber(class)
	sub = tonumber(sub)

	text = WhatsFactionInfo[expantion][faction][0]

	if standing ~= nil and standing ~= "" and standing ~= "0" then
		text = text.." "..WhatsStandingInfo[tonumber(standing)]..":"
	else
		text = text..":"
	end

	if class > 0 and WhatsClassInfo[class] then
		text = text.." "..WhatsClassInfo[class][0].." "
		if sub > 0 and WhatsClassInfo[class][sub]then
			text = text .."("..WhatsClassInfo[class][sub][0]..") "
		end
	else
		text = text.." "..WhatsItemMenu[t[5]].." "
	end
	

	for item,num in string.gmatch(require,"(%d*)-?(%d*)") do
		if item ~= nil and item ~= "" then
			item = tonumber(item)
			local n = self:GetLink(item)
			if n ~= nil then
				text = text..n
			else
				text = text.."Item:"..item
			end
			if num ~= nil and num ~= "" and num ~= "1" then
				text = text.."x"..num.." "
			else
				text = text.." "
			end
			if WhatsItemInfo[item] then
				local temp = self:Parse(item)
				if temp[1] == "I" or temp[1] == "Ib" or temp[1] == "Ih"then
					text = text.."( "

					for ConNum, InsNum, MobNum in string.gmatch(temp[2], "(%d+)-(%d+)-(%d+)") do
						ConNum = tonumber(ConNum)
						InsNum = tonumber(InsNum)
						MobNum = tonumber(MoBNum)

						text = text.."|CFFFFFFFF"..WhatsMobInfo[ConNum][InsNum][MobNum][0].."|r "
					end

					text = text..") "
				end
			end
		end
	end

	
	if text ~= nil then
		return text
	end
end

function Whats:BattleGroundItem(t, chat)
	local faction, point, require, text

	_, _, point, require = strfind(t[3], "(%d*):?(.*)")

	for faction in string.gmatch(t[2],"(%d+)") do
		faction = tonumber(faction)
		if text ~= nil then
			text = text .."/".. WhatsBGInfo[faction][0]
		else
			text = WhatsBGInfo[faction][0]
		end
	end
	text = text.." : "

	
	text = text..WhatsItemMenu[t[5]].." "

	if point and point ~= "" and tonumber(point) > 0 then
		text = text ..L["PvP"] .. " ".. L["Point"] .. " "..point..L["p"].." "
	end

	for item,num in string.gmatch(require,"(%d*)-?(%d*)") do
		if item ~= nil and item ~= "" then
			item = tonumber(item)
			local n = self:GetLink(item)
			if n ~= nil then
				text = text..n
			else
				text = text.."Item:"..item
			end
			if num ~= nil and num ~= "" and num ~= "1" then
				text = text.."x"..num.." "
			else
				text = text.." "
			end
		end
	end


	
	if text ~= nil then
		return text
	end
end

function Whats:PvPItem(t, chat)

	local expantion, faction, class, sub, point, require, text
	_, _, expantion, faction, class, sub = strfind(t[2], "(%d+)-(%d+)-(%d+)-(%d+)")
	_, _, point, require = strfind(t[3], "(%d*):?(.*)")

	expantion = tonumber(expantion)
	faction = tonumber(faction)
	class = tonumber(class)
	sub = tonumber(sub)
	point = tonumber(point)

	text = WhatsPointInfo[0].. "("..WhatsPointInfo[expantion][0]..") - "..(faction == 3 and L["Both"] or WhatsPointInfo[expantion][faction][0]).." : "
		
	if class > 0 and WhatsClassInfo[class] then
		text = text.." "..WhatsClassInfo[class][0].." "
		if sub > 0 and WhatsClassInfo[class][sub]then
			text = text .."("..WhatsClassInfo[class][sub][0]..") "
		end
	else
		text = text.." "..WhatsItemMenu[t[5]].." "
	end

	if point == 0 and require == "" then
		text = text..L["Sold Out"]
	else
		text = text .. L["PvP"] .. " ".. L["Point"] .. " "..point..L["p"].." "
	end

	for item,num in string.gmatch(require,"(%d*)-?(%d*)") do
		if item ~= nil and item ~= "" then
			item = tonumber(item)
			local n = self:GetLink(item)
			if n ~= nil then
				text = text..n
			else
				text = text.."Item:"..item
			end
			if num ~= nil and num ~= "" and num ~= "1" then
				text = text.."x"..num.." "
			else
				text = text.." "
			end
		end
	end
	
	if text ~= nil then
		return text
	end
end

function Whats:GetText(itemid, chat)
	local text 
	local temp = self:Parse(itemid)

	if ( temp[1] == "I" or temp[1] == "Ib" or temp[1] == "Ih") then
		text = self:InstanceDrop(temp, chat)
	elseif ( temp[1] == "E" ) then
		text = self:ExchangeItem(temp, chat)
	elseif ( temp[1] == "A" ) then
		text = self:ArenaItem(temp, chat)
	elseif ( temp[1] == "P" ) then
		text = self:PvPItem(temp, chat)
	elseif ( temp[1] == "F" ) then
		text = self:ReputationItem(temp, chat)
	elseif ( temp[1] == "B" ) then
		text = self:BattleGroundItem(temp, chat)
	end

	return text

end

function Whats:AddInfoToTooltip(itemid, tooltip)
	local text = self:GetText(itemid, false)
	if text ~= nil then
		tooltip:AddLine("|CFF00CED1W|r|CFFFFFFFFhats: "..text.."|r", 1, 1, 1, 1)
	end
end

function Whats:GetLink(itemid)

	if WhatsItemDB[itemid] and select(3, string.find(WhatsItemDB[itemid], "%[(.+)%]")) and strlen(select(3, string.find(WhatsItemDB[itemid], "%[(.+)%]"))) > 1 then
		return WhatsItemDB[itemid]
	else
		local _, link = GetItemInfo(itemid)
		if link ~= nil and select(3, string.find(link, "%[(.+)%]")) and strlen(select(3, string.find(link, "%[(.+)%]"))) > 1 then
			WhatsItemDB[itemid] = link
			return link
		end
		return nil
	end

end

function Whats:OpenFrame(num, table)
	if _G["WhatsMenu"..num] then
		local 	n = 1
		while (_G["WhatsButton"..n]) do
			_G["WhatsButton"..n]:Hide()
			n = n + 1
		end

		local frame = _G["WhatsMenu"..num]
		frame:Show()
		frame.text:SetText(table[0])
		frame.index = num
		frame.table = table
		return frame
	else
		local n = 1
		while (_G["WhatsButton"..n]) do
			_G["WhatsButton"..n]:Hide()
			n = n + 1
		end
		return self:CreatFrame(num, table)
	end

end

function Whats:Parse(text)
	local tempTable = { }
	local num = 1
	if type(text) == "number" then
		for t in string.gmatch(WhatsItemInfo[tonumber(text)], "([^/]+)") do
			tempTable[num] = t
			num = num + 1
		end
		return tempTable
	else
		for t in string.gmatch(text, "([^/]+)") do
			tempTable[num] = t
			num = num + 1
		end
		return tempTable
	end

end

local ItemColorTable = {
	[0] = "9d9d9d",
	[1] = "ffffff",
	[2] = "1eff00",
	[3] = "0070dd",
	[4] = "a335ee",
	[5] = "ff8000",
	[6] = "e6cc80",
}

function Whats:OpenButton(num, itemid)

	local frame

	if _G["WhatsButton"..num] then
		frame = _G["WhatsButton"..num]
	else
		frame = self:CreatButton(num)
	end

	frame.link = nil
	frame.itemid = itemid

	local table = self:Parse(itemid)

	local icon = select(10, GetItemInfo(itemid))
	if icon ~= nil and icon ~= "" then
		_G["WhatsButton"..num.."Icon"]:SetTexture(icon)

	else
		if table[8] then
			_G["WhatsButton"..num.."Icon"]:SetTexture("Interface\\Icons\\"..table[8])
		else
			_G["WhatsButton"..num.."Icon"]:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")
		end
	end

	local Link = WhatsItemDB[itemid]

	local name = select(2, GetItemInfo(itemid))
	if name ~= nil then
		frame.itemname:SetText(name)
		frame.link = name
		_G["WhatsButton"..num]:SetBackdropColor(self.db.profile.Ccolor.r, self.db.profile.Ccolor.g, self.db.profile.Ccolor.b, self.db.profile.Ccolor.a)
	else
		if Link and select(3, string.find(Link, "%[(.+)%]")) and strlen(select(3, string.find(Link, "%[(.+)%]"))) > 1 then
			frame.itemname:SetText(WhatsItemDB[itemid])
			frame.link = WhatsItemDB[itemid]
			_G["WhatsButton"..num]:SetBackdropColor(self.db.profile.Ucolor.r, self.db.profile.Ucolor.g, self.db.profile.Ucolor.b, self.db.profile.Ucolor.a)
		else
			if table[4] then
				local colorCode = ItemColorTable[tonumber(table[4])]
				frame.itemname:SetText("|cff"..colorCode.."["..itemid.."]|r")
			else
				frame.itemname:SetText("["..itemid.."]")
			end
			_G["WhatsButton"..num]:SetBackdropColor(self.db.profile.Ncolor.r, self.db.profile.Ncolor.g, self.db.profile.Ncolor.b, self.db.profile.Ncolor.a)
		end
	end

	if table[5] then
		frame.itemtype:SetText(WhatsItemType[table[5]])
	else
		frame.itemtype:SetText(L["Unchecked"])
	end

	frame:Show()
end

function Whats:OpenList(temp)
	if type(temp) == "table" then
		local num = 1
		for _, v in pairs(temp) do
			Whats:OpenButton(num, tonumber(v))
			num = num + 1
		end

	else
		local _, _, type, mob = string.find(temp, "(%a+)/(.+)")
		local num = 1

		for k, v in pairs(WhatsItemInfo) do
			local flag  = flase
			if type == "I" and strsub(v, 1, 2) == "I/" then flag= true end
			if type == "Ih" and (strsub(v, 1, 2) == "Ib" or strsub(v, 1, 2) == "Ih") then flag = true end
			if type == "In" and (strsub(v, 1, 2) == "Ib" or strsub(v, 1, 2) == "I/")  then flag = true end
			if flag then
				local _, _, _, mobText = string.find(v, "^I(%l*)/([^/]+)/")
				for mobCode in string.gmatch(mobText, "([%d%-]+)") do
					if mobCode == mob then
						local itemid = tonumber(k)
						Whats:OpenButton(num, itemid)
						num = num + 1
					end
				end
			end
		end
	end
end

function Whats:MenuClick(frame, button)
	if button == "RightButton" then
		return
	end

	local index = tonumber(frame.index)
	local temp = frame.table
	local pattern = frame.pattern

	if ( not temp[1] and temp["item"] ) or ( not temp[0] and _G["WhatsMenu1"].pattern == 1) then
		return
	end

	local n = index + 1
	while (_G["WhatsMenu"..n]) do
		_G["WhatsMenu"..n]:Hide()
		n = n + 1
	end

	n = 1
	while ( _G["WhatsButton"..n] ) do
		_G["WhatsButton"..n]:Hide()
		n = n + 1
	end
	

	DD:Open(frame,
		"point", function() return "TOPLEFT", "TOPRIGHT" end,
		"dontHook", true,
		"children", function ()
			if temp["hard"] and frame.text:GetText() ~= L["Normal"] and frame.text:GetText() ~= L["Hard"] then
				local table = frame.table
				DD:AddLine(
					"text", L["Normal"],
					"func", function ()
						local f = Whats:OpenFrame(index+1, table)
						f.text:SetText(L["Normal"])
						f.pattern = pattern.."/n"
						DD:Close()
				end)
				DD:AddLine(
					"text", L["Hard"],
					"func", function ()
						local f = Whats:OpenFrame(index+1, table)
						f.text:SetText(L["Hard"])
						f.pattern = pattern.."/h"
						DD:Close()
				end)
			else
				if not temp[0] then
					if frame.table[1] then				
						local num = 1
						while (temp[1][num]) do
							local table = frame.table[1][num]
							DD:AddLine(
								"text", table[0],
								"func", function ()
									local f = Whats:OpenFrame(index+1, table)
									f.pattern = pattern
									if table["item"] then
										self:OpenList(table["item"])
									end
									DD:Close()
							end)
							num = num + 1
						end
					end
					if frame.table[2] then				
						local num = 1
						while (temp[2][num]) do
							local table = frame.table[2][num]
							DD:AddLine(
								"text", table[0],
								"func", function ()
									local f = Whats:OpenFrame(index+1, table)
									f.pattern = pattern
									if table["item"] then
										self:OpenList(table["item"])
									end
									DD:Close()
							end)
							num = num + 1
						end
					end

				else
					local num = 1
					while (temp[num]) do
						local table = frame.table[num]
						if frame.text:GetText() == L["Normal"] and table["OH"] then
						else
							local i 
							if pattern ~= "" then
								i = pattern.."/"..num
							else
								i = num
							end
							DD:AddLine(
								"text", table[0],
								"func", function ()
									local f = Whats:OpenFrame(index+1, table)
									f.pattern = i
									if not table[1] then
										if table["item"] then
											self:OpenList(table["item"])
										else
											self:GetTable(f.pattern)
											f.table = menuTable
										end
									end
									DD:Close()
							end)
						end
						num = num + 1
					end
				end
			end
	end)

end

local itemTypeTable = {
	[1] = "I",
	[2] = "E",
	[3] = "F",
	[4] = "A",
	[5] = "B",
	[6] = "P",
}

function Whats:GetTable(text)
	local typeTable = self:Parse(text)
	local typeText
	local i = 1
	while (typeTable[i]) do
		if i == 1 then
			typeText = itemTypeTable[tonumber(typeTable[i])]
			if typeTable[4] == "n" or typeTable[4] == "h" then
				typeText = typeText..typeTable[4]
			end
			typeText = typeText.."/"
		elseif i == 2 then
			typeText = typeText .. typeTable[i]
		elseif i == 4 and ( typeTable[4] == "n" or typeTable[4] == "h") then
		else
			typeText = typeText .. "-"..typeTable[i]
		end
		i = i + 1
	end
	local l = strlen(typeText)

	menuTable = { }
	
	if typeTable[1] == "1" then
		self:OpenList(typeText)
		return
	end

	for k, v in pairs(WhatsItemInfo) do
		if strsub(v, 1, l) == typeText then
			local temp = self:Parse(tonumber(k))
			local class, sub, check
			if temp[1] == "F" then
				_, _, _, check, class, sub = string.find(temp[2], "^(%d+)%-(%d+)%-(%d+)%-(%d+)$")
			elseif temp[1] == "A" then
				_, _, _, class, sub = string.find(temp[2], "^(%d+)%-(%d+)%-(%d+)$")
			elseif temp[1] == "P" then
				_, _, _, _, class, sub = string.find(temp[2], "^(%d+)%-(%d+)%-(%d+)%-(%d+)$")
			elseif temp[1] == "E" or temp[1] == "B" then
				class = nil
				sub = nil
			end
			if ( typeTable[1] == "3"  and check == typeTable[3] ) or typeTable[1] ~= "3" then

				if class ~= nil then
					class = tonumber(class)
					if sub ~= nil then
						sub = tonumber(sub)
					end
				end

				if class ~= nil and class > 0 then
					if not menuTable[1] then
						menuTable[1] = {
						}
					end
					if not menuTable[1][class] then
						menuTable[1][class] = {
							[0] = WhatsClassInfo[class][0],
							["item"] = {
							}
						}
					end
					if sub ~= nil and sub > 0 then
						if not menuTable[1][class][sub] then
							menuTable[1][class][sub] = {
								[0] = WhatsClassInfo[class][sub][0],
								["item"] = {
								}
							}
						end

						table.insert(menuTable[1][class][sub]["item"], k)
					else	
						table.insert(menuTable[1][class]["item"], k)
					end

				else
					if not menuTable[2] then
						menuTable[2] = {
						}
					end
					local num = 1
					local flag = true
					while (menuTable[2][num] ) do
						if menuTable[2][num][0] == WhatsItemMenu[temp[5]] then
							table.insert(menuTable[2][num]["item"], k)
							flag = false
							break;
						end
						num = num + 1
					end
					if flag == true then
						menuTable[2][num] = {
							[0] = WhatsItemMenu[temp[5]],
							["item"] = {
							},
						}
						table.insert(menuTable[2][num]["item"], k)
					end
				end
			end
		end
	end
end

function Whats:HideTooltip(frame)
	GameTooltip:Hide()
end

function Whats:ShowTooltip(frame)
	local itemid = frame.itemid
	
	local _, Link = GetItemInfo(frame.itemid)
	if Link then
		GameTooltip:SetOwner(this, "ANCHOR_NONE")
		GameTooltip:SetPoint("TOPLEFT", frame.icon, "BOTTOMLEFT", -2, 3)
		GameTooltip:SetHyperlink(Link)
		GameTooltip:Show()
	else
		GameTooltip:SetOwner(this, "ANCHOR_NONE")
		GameTooltip:SetPoint("TOPLEFT", frame.icon, "BOTTOMLEFT", -2, 3)
		if WhatsItemDB[tonumber(itemid)] and select(3, string.find(WhatsItemDB[itemid], "%[(.+)%]")) and strlen(select(3, string.find(WhatsItemDB[itemid], "%[(.+)%]"))) > 1 then
			GameTooltip:SetText(WhatsItemDB[tonumber(itemid)], 1, 0, 0, 1)
		else
			local table = self:Parse(itemid)
			local colorCode = ItemColorTable[tonumber(table[4])]
			if table[4] then
				GameTooltip:SetText("|cff"..colorCode.."["..itemid.."]|r", 1, 0, 0, 1)
			else
				GameTooltip:SetText("["..itemid.."]", 1, 0, 0, 1)
			end
		end
		GameTooltip:AddLine(L["This Item is not found, click to query server.\n|cFFFF2222WARNING: This WILL disconnect you if the server has not seen the item.|r"], NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1)
		GameTooltip:Show()
	end
end

function Whats:ClickItem(frame)
	if frame.link ~= nil then

		if IsControlKeyDown() then
			DressUpItemLink(frame.link);
		elseif IsShiftKeyDown() then
			if not ChatFrameEditBox:IsVisible() then
				ChatFrameEditBox:Show()
			end
			ChatFrameEditBox:Insert(frame.link)
		elseif	 IsAltKeyDown() then
			if not ChatFrameEditBox:IsVisible() then
				ChatFrameEditBox:Show()
			end
			ChatFrameEditBox:Insert("|CFF00CED1W|r|CFFFFFFFFhats|r:".. frame.link .. " "..self:GetText(frame.itemid, true))
		else
			ShowUIPanel(ItemRefTooltip)
			if not ItemRefTooltip:IsVisible() then
				ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
			end
			ItemRefTooltip:SetHyperlink(frame.link)
		end
	else
		GameTooltip:SetOwner(this, "ANCHOR_PRESERVE")
		GameTooltip:SetHyperlink("item:" .. frame.itemid)
		GameTooltip:Hide()
		local ScheduleName = "WhatsShowItem"..frame.index
		local num = frame.index
		local itemid = frame.itemid
		Whats:ScheduleRepeatingEvent(ScheduleName, function() self:CancelScheduledEvent(ScheduleName) self:OpenButton(num, itemid) end, 2.5, Whats)
		
	end
end

function Whats:CreatFrame(index, table)
	local frame = CreateFrame("BUTTON", 'WhatsMenu'..index, index == 0 and UIParent or _G["WhatsMenu"..index-1])

	frame.index = index
	frame.table = table

	frame:SetFrameStrata("DIALOG")
	frame:SetWidth(self.db.profile.menuWidth)
	frame:SetHeight(25)
	frame:SetBackdrop(
		{
			bgFile = SharedMedia:Fetch('background', self.db.profile.texture),
			edgeFile = SharedMedia:Fetch('border', self.db.profile.border),
			tile="false",
			edgeSize = 8,
			insets = {
						left = 0,
						right = 0,
						top = 0,
						bottom = 0
					}
		})
	frame:SetBackdropColor(self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a)
	if index == 0 then
		frame:SetMovable(true)
		frame:SetScript("OnMouseDown", function() frame:StartMoving() end)
		frame:SetScript("OnMouseUp", function() frame:StopMovingOrSizing() end)
	end

	frame:SetScript("OnClick", function(frame, button) self:MenuClick(frame, button) end)

	frame:EnableMouse(true)

	frame:RegisterForDrag("LeftButton", "RightButton")
	frame:RegisterForClicks("LeftButtonUp","RightButtonUp","MiddleButtonUp","Button4Up","Button5Up")

	frame.text = frame:CreateFontString("Whats"..index.."Title","OVERLAY","GameFontNormal")
	frame.text:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 12)
	frame.text:SetText(frame.table[0])
	frame.text:SetPoint("CENTER", frame, "CENTER", 0, 0)

	frame.pattern = nil

	frame:ClearAllPoints()
	
	if index ~= 0 then
		if self.db.profile.growth == "U" then
			frame:SetPoint("BOTTOM", _G["WhatsMenu"..index-1], "TOP", 0, 2)
		elseif self.db.profile.growth == "D" then
			frame:SetPoint("TOP", _G["WhatsMenu"..index-1], "BOTTOM", 0, -2)
		elseif self.db.profile.growth == "L" then
			frame:SetPoint("TOPRIGHT", _G["WhatsMenu"..index-1], "TOPLEFT", -2, 0)
		elseif self.db.profile.growth == "R" then
			frame:SetPoint("TOPLEFT", _G["WhatsMenu"..index-1], "TOPRIGHT", 2, 0)
		end
	else
		frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end
	return frame
end

function Whats:CreatButton(index)
	local index = tonumber(index)
	local frame = CreateFrame("Button", "WhatsButton"..index, index == 1 and _G["WhatsMenu0"] or _G["WhatsButton"..index-1])
	frame.index = index
	frame.itemid = nil
	frame.link = nil

	frame:SetFrameStrata("DIALOG")
	frame:SetWidth(self.db.profile.buttonWidth)
	frame:SetHeight(27)
	frame:SetBackdrop(
		{
			bgFile = SharedMedia:Fetch('background', self.db.profile.texture),
			edgeFile = SharedMedia:Fetch('border', self.db.profile.border),
			tile="false",
			edgeSize = 8,
			insets = {
						left = 0,
						right = 0,
						top = 0,
						bottom = 0
					}
		})
	frame:SetBackdropColor(1, 1, 1)
	frame:EnableMouse(true)
	frame:EnableKeyboard(true)

	frame.icon = frame:CreateTexture("WhatsButton"..index.."Icon", "ARTWORK") 
	frame.icon:SetHeight(25)
	frame.icon:SetWidth(25)
	frame.icon:ClearAllPoints();
	frame.icon:SetPoint("TOPLEFT", frame, "TOPLEFT", 1, -1)
	frame.icon:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")


	frame:SetScript("OnLeave", function(frame)  self:HideTooltip(frame)end)
	frame:SetScript("OnEnter", function(frame) self:ShowTooltip(frame) end)
	frame:SetScript("OnClick", function(frmae)  self:ClickItem(frame) end)

	frame.itemname = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	frame.itemname:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 10)
	frame.itemname:SetText("")
	frame.itemname:SetPoint("TOPLEFT", frame.icon, "TOPRIGHT", 2, -1)

	frame.itemtype = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	frame.itemtype:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 10)
	frame.itemtype:SetText("")
	frame.itemtype:SetPoint("BOTTOMLEFT", frame.icon, "BOTTOMRIGHT", 2, 1)

	frame:ClearAllPoints()

	if self.db.profile.growth == "U" then
		if index == 1 then
			frame:SetPoint("TOPLEFT", _G["WhatsMenu0"], "TOPRIGHT", 2, 0)
		elseif index > self.db.profile.column and mod(index, self.db.profile.column) == 1 then
			frame:SetPoint("BOTTOM", _G["WhatsButton"..index-self.db.profile.column], "TOP", 0, 1)
		else
			frame:SetPoint("TOPLEFT", _G["WhatsButton"..index-1], "TOPRIGHT", 1, 0)
		end
	elseif self.db.profile.growth == "D" then
		if index == 1 then
			frame:SetPoint("TOPLEFT", _G["WhatsMenu0"], "TOPRIGHT", 2, 0)
		elseif index > self.db.profile.column and mod(index, self.db.profile.column) == 1 then
			frame:SetPoint("TOP", _G["WhatsButton"..index-self.db.profile.column], "BOTTOM", 0, -1)
		else
			frame:SetPoint("TOPLEFT", _G["WhatsButton"..index-1], "TOPRIGHT", 1, 0)
		end
	elseif self.db.profile.growth == "L" then
		if index == 1 then
			frame:SetPoint("TOPRIGHT", _G["WhatsMenu0"], "BOTTOMRIGHT", 0, -2)
		elseif index > self.db.profile.column and mod(index, self.db.profile.column) == 1 then
			frame:SetPoint("TOP", _G["WhatsButton"..index-self.db.profile.column], "BOTTOM", 0, -1)
		else
			frame:SetPoint("TOPRIGHT", _G["WhatsButton"..index-1], "TOPLEFT", 1, 0)
		end
	elseif self.db.profile.growth == "R" then
		if index == 1 then
			frame:SetPoint("TOPLEFT", _G["WhatsMenu0"], "BOTTOMLEFT", 0, -2)
		elseif index > self.db.profile.column and mod(index, self.db.profile.column) == 1 then
			frame:SetPoint("TOP", _G["WhatsButton"..index-self.db.profile.column], "BOTTOM", 0, -1)
		else
			frame:SetPoint("TOPLEFT", _G["WhatsButton"..index-1], "TOPRIGHT", 1, 0)
		end
	end
	return frame
end




function Whats:ApplySetting()
	local num = 1

	while ( _G["WhatsButton"..num] ) do
		_G["WhatsButton"..num]:SetBackdrop(
		{
			bgFile = SharedMedia:Fetch('background', self.db.profile.texture),
			edgeFile = SharedMedia:Fetch('border', self.db.profile.border),
			tile="false",
			edgeSize = 8,
			insets = {
						left = 0,
						right = 0,
						top = 0,
						bottom = 0
					}
		})
		_G["WhatsButton"..num]:SetWidth(self.db.profile.buttonWidth)
		_G["WhatsButton"..num]:ClearAllPoints()
		_G["WhatsButton"..num].itemname:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 10)
		_G["WhatsButton"..num].itemtype:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 10)

		if self.db.profile.growth == "U" then
			if num == 1 then
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsMenu0"], "TOPRIGHT", 2, 0)
			elseif num > self.db.profile.column and mod(num, self.db.profile.column) == 1 then
				_G["WhatsButton"..num]:SetPoint("BOTTOM", _G["WhatsButton"..num-self.db.profile.column], "TOP", 0, 1)
			else
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsButton"..num-1], "TOPRIGHT", 1, 0)
			end
		elseif self.db.profile.growth == "D" then
			if num == 1 then
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsMenu0"], "TOPRIGHT", 2, 0)
			elseif num > self.db.profile.column and mod(num, self.db.profile.column) == 1 then
				_G["WhatsButton"..num]:SetPoint("TOP", _G["WhatsButton"..num-self.db.profile.column], "BOTTOM", 0, -1)
			else
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsButton"..num-1], "TOPRIGHT", 1, 0)
			end
		elseif self.db.profile.growth == "L" then
			if num == 1 then
				_G["WhatsButton"..num]:SetPoint("TOPRIGHT", _G["WhatsMenu0"], "BOTTOMRIGHT", 0, -2)
			elseif num > self.db.profile.column and mod(num, self.db.profile.column) == 1 then
				_G["WhatsButton"..num]:SetPoint("TOP", _G["WhatsButton"..num-self.db.profile.column], "BOTTOM", 0, -1)
			else
				_G["WhatsButton"..num]:SetPoint("TOPRIGHT", _G["WhatsButton"..num-1], "TOPLEFT", 1, 0)
			end
		elseif self.db.profile.growth == "R" then
			if num == 1 then
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsMenu0"], "BOTTOMLEFT", 0, -2)
			elseif num > self.db.profile.column and mod(num, self.db.profile.column) == 1 then
				_G["WhatsButton"..num]:SetPoint("TOP", _G["WhatsButton"..num-self.db.profile.column], "BOTTOM", 0, -1)
			else
				_G["WhatsButton"..num]:SetPoint("TOPLEFT", _G["WhatsButton"..num-1], "TOPRIGHT", 1, 0)
			end
		end
		num = num + 1
	end
	num = 0
	while ( _G["WhatsMenu"..num] ) do
		_G["WhatsMenu"..num]:SetBackdrop(
		{
			bgFile = SharedMedia:Fetch('background', self.db.profile.texture),
			edgeFile = SharedMedia:Fetch('border', self.db.profile.border),
			tile="false",
			edgeSize = 8,
			insets = {
						left = 0,
						right = 0,
						top = 0,
						bottom = 0
					}
		})
		_G["WhatsMenu"..num]:SetWidth(self.db.profile.menuWidth)
		_G["WhatsMenu"..num]:SetBackdropColor(self.db.profile.Mcolor.r, self.db.profile.Mcolor.g, self.db.profile.Mcolor.b, self.db.profile.Mcolor.a)
		_G["WhatsMenu"..num].text:SetFont(SharedMedia:Fetch('font', self.db.profile.font), 12)

		if num ~= 0 then
			_G["WhatsMenu"..num]:ClearAllPoints()
		end
		if num ~= 0 then
			if self.db.profile.growth == "U" then
				_G["WhatsMenu"..num]:SetPoint("BOTTOM", _G["WhatsMenu"..num-1], "TOP", 0, 2)
			elseif self.db.profile.growth == "D" then
				_G["WhatsMenu"..num]:SetPoint("TOP", _G["WhatsMenu"..num-1], "BOTTOM", 0, -2)
			elseif self.db.profile.growth == "L" then
				_G["WhatsMenu"..num]:SetPoint("TOPRIGHT", _G["WhatsMenu"..num-1], "TOPLEFT", -2, 0)
			elseif self.db.profile.growth == "R" then
				_G["WhatsMenu"..num]:SetPoint("TOPLEFT", _G["WhatsMenu"..num-1], "TOPRIGHT", 2, 0)
			end
		end
		num = num + 1
	end
end
